{ WinnyBBSpNXQ }
unit UBbsWinny;

interface

uses
  SysUtils, StrUtils;

function InStr(S,SubStr:String; PFrom: Integer = 1): Integer;
function Len(S:String): Integer;
function MidStrF(S: String; PFrom: Integer; PTo: Integer = -1): String;

function WinnyConvSubject(html: String) : String;
function WinnyConvSubject2(txt: String) : String;
procedure WinnySeparateHash2(Str: string; Size: integer; var Keyword: string; var Hash: string);
function WinnySeparateBoard(var Keyword: string): string;
function ShingetsuConvSubject(txt: String) : String;
function SeparateWord(word: string; var Str: string): string;

implementation

function InStr(S, SubStr:String; PFrom: Integer = 1): Integer;
var
  n: Integer;
  t: String;
begin
  if PFrom < 1 then begin
    PFrom := 1;
  end;
  t := Copy(S, PFrom, Length(S) - PFrom + 1);
  n := Pos(SubStr, t);
  if n>0 then begin
    n := n + PFrom - 1;
  end;
  InStr := n;
end;

// Len:̒ԂB
function Len(S:String): Integer;
begin
  Len:=Length(S);
end;


// MidStrF:ʒuPFromPTo܂ł̕𔲂oB
function MidStrF(S: String; PFrom: Integer; PTo: Integer = -1): String;
begin
  if PTo = -1 then begin
    PTo := Len(S);
  end;
  if PTo < PFrom then begin
    result := '';
  end else begin
    result := Copy(S, PFrom, PTo - PFrom + 1);
  end;
end;

function RestoreHTMLText(s:String): String;
var
  i: Integer;
  c: String;
  f: Boolean;
begin
  s := AnsiReplaceText(s, '&gt;', '>');
  s := AnsiReplaceText(s, '&lt;', '<');
  s := AnsiReplaceText(s, '&quot;', '"');
  {DONE: Unicode̕}
  s := AnsiReplaceText(s, '&amp;', '&');
  s := AnsiReplaceText(s, '<br>', #13#10);

    { ^O𔲂ďo͂ }
  f := true;
  result := '';
  for i := 1 to Len(s) do begin
    c := MidStr(s, i, 1);
    if c = '<' then f := false;
    if f then result := result + c;
    if c = '>' then f := true;
  end;
end;

function WinnyConvSubject(html: String) : String;

var
	resultText: String;
	tl, ts: String;
	brp, rp, p, p2, p3, p4: Integer;
	cnt: String;
	workStr: String;
        tmpStr: String;

begin

(* sample
  <font color=black>03/11/24 03:41</font> <a href="19bd3112af0e3effd624f20f19a7a111">[BBS_Winny]@@(ÉE)@EBjBBB[[[[I</a> [    435 ] <br>
*)

	rp := 1;
	resultText := '';

	if InStr(html, 'Xbhꗗ</title>') < 1 then begin
		result := resultText;
		exit;
	end;

	while rp < Len(html) do begin
		brp := rp;
		rp := InStr(html, '<font', rp + 5000);	// ̂2000̋؂̗ǂƂŐ؂
		if rp = 0 then begin
			rp := Len(html) + 1;
		end;
		tl := MidStrF(html, brp, rp - 1);

		p := InStr(tl, '<font');
		while p > 0 do begin
			workStr := '';

			{ html̉ }
			p2 := InStr(tl, '<br>', p);
			if p2 = 0 then begin
				ts := MidStrF(tl, p, Len(tl));
			end else begin
				ts := MidStrF(tl, p, p2 - 1);
			end;

//		tmp.BoardType := StrToInt(RightStr(BoardRoot, 1));

			p3 := InStr(tl, '>', p) + 1;
			p4 := InStr(tl, '</font>', p3) - 1;
			if (p3 > 1) and (p4 > 0) then begin
//				tmp.Update := MidStrF(tl, p3, p4);	(* XV *)
			end;
			if p4 > 0 then begin
				p3 := InStr(tl, '<a href="', p4) + 9;
				p4 := InStr(tl, '"', p3) - 1;
				if (p3 > 9) and (p4 > 0) then begin
					workStr := workStr + MidStrF(tl, p3, p4) + '.dat';	(* XbhID *)
				end;
			end;
			if p4 > 0 then begin
				p3 := InStr(tl, '>', p4) + 1;
				p4 := InStr(tl, '</a>', p3) - 1;
				if (p3 > 1) and (p4 > 0) then begin
                                        tmpStr := RestoreHTMLText(MidStrF(tl, p3, p4));
                                        p3 := AnsiPos('] ', tmpStr);
                                        if p3 > 0 then begin
                                          tmpStr := MidStrF(tmpStr, p3 + 2);
                                        end else begin
                                          p3 := AnsiPos(']', tmpStr);
                                          if p3 > 0 then begin
                                            tmpStr := MidStrF(tmpStr, p3 + 1);
                                          end;
                                        end;
					workStr := workStr + '<>' + tmpStr;	(* Xbh^Cg *)
				end;
			end;
			if p4 > 0 then begin
				p3 := InStr(tl, '[', p4 + 4) + 1;
				p4 := InStr(tl, ']', p3) - 1;
				if (p3 > 1) and (p4 > 0) then begin
					cnt := Trim(MidStrF(tl, p3, p4));
					workStr := workStr + '(' + cnt + ')';	(* XbhX *)
				end;
			end;

			resultText := resultText + workStr + #10;

			p := InStr(tl, '<font', p + 1);

		end;
	end;
	result := resultText;
end;

function WinnyConvSubject2(txt: String) : String;
var
  endOfRec: integer;

  (* ؂T *)
  function findDelimiter(i: integer): integer;
  begin
    while (i <= endOfRec) do
    begin
      if (txt[i] < #$20) or (txt[i] = #$7f) then
      begin
        break;
      end;
      if (i + 1 <= endOfRec) and (txt[i] = '<') and (txt[i + 1] = '>') then
      begin
        break;
      end;
      Inc(i);
    end;
    result := i;
  end;

  function skipEOR(i: integer): integer;
  begin
    while (i <= endOfRec) do
    begin
      if (txt[i] < #$20) or (txt[i] = #$7f) then
      begin
        break;
      end;
      Inc(i);
    end;
    result := i;
  end;

var
  i, n: integer;
  s, subjectName, datName, resNum, lastDate: string;
begin
  s := '';
  endOfRec := Length(txt);
  i := 1;
  while i < endOfRec do
  begin
    n := findDelimiter(i);
    if (n = i) then
    begin
      n := skipEOR(i);
      i := n + 1;
    end
    else
    begin
      subjectName := Copy(txt, i, n - i);
      i := n + 2;

      n := findDelimiter(i);
      datName := Copy(txt, i, n - i);
      i := n + 2;

      n := findDelimiter(i);
      resNum := Copy(txt, i, n - i);
      i := n + 2;

      n := findDelimiter(i);
      i := n + 2;

      n := findDelimiter(i);
      lastDate := Copy(txt, i, n - i);
      i := n + 2;

      n := skipEOR(i);
      i := n + 1;

      s := s + datName + '<>' + subjectName + '(' + resNum + ')' + #10;
    end;
  end;
  result := s;
end;

function Copy2(Str: string; Index: integer; Count: integer): string;
var
  n: integer;
begin
  n := Length(Str);
  if n > Index - 1 then begin
    if Count = -1 then begin
      Count := n - (Index - 1);
    end;
    result := Copy(Str, Index, Count);
  end else begin
    result := '';
  end;
end;

function SeparateWord2(word: string; var Str: string): string;
var
  n: integer;
  nn: integer;
  function Pos2(const SubStr: string; const Str: string): integer;
  var
    s: string;
    n1: integer;
    n2: integer;
  begin
    s := SubStr;
    n1 := AnsiPos(s, Str);
    s := LowerCase(SubStr);
    n2 := AnsiPos(s, Str);
    if n1 <= 0 then begin
      result := n2;
    end else if n2 <= 0 then begin
      result := n1;
    end else if n1 < n2 then begin
      result := n1;
    end else begin
      result := n2;
    end;
  end;
begin
  n := Pos2(word, Str);
  if n <= 0 then begin
    result := Str;
    Str := '';
  end else begin
    nn := Length(word);
    result := Copy(Str, 1, n - 1);
    Str := Copy2(Str, n + nn, -1);
  end;
end;

function SeparateWord(word: string; var Str: string): string;
var
  n: integer;
  nn: integer;
begin
  n := AnsiPos(word, Str);
  if n <= 0 then begin
    result := Str;
    Str := '';
  end else begin
    nn := Length(word);
    result := Copy(Str, 1, n - 1);
    Str := Copy2(Str, n + nn, -1);
  end;
end;

function SeparateQuote(var Str: string): string;
var
  n1: integer;
  n2: integer;
begin
  n1 := AnsiPos('"', Str);
  n2 := AnsiPos('''', Str);
  if (n1 <= 0) or ((n2 > 0) and (n2 < n1)) then begin
    n1 := n2;
  end;
  if n1 <= 0 then begin
    result := Str;
    Str := '';
  end else begin
    result := Copy(Str, 1, n1 - 1);
    Str := Copy2(Str, n1 + 1, -1);
  end;
end;

function ConvCommaToSpace(Str: string): string;
var
  n: integer;
  i: integer;
  c: char;
begin
  result := '';
  n := Length(Str);
  for i := 1 to n do begin
    c := Str[i];
    if c = ',' then begin
      result := result + ' ';
    end else begin
      result := result + c;
    end;
  end;
end;

procedure SeparateComma(Str: string; var Tbl: array of string);
var
  n: integer;
  i: integer;
begin
  for i := 0 to 5 do begin
    n := AnsiPos(',', Str);
    if n <= 0 then begin
      Tbl[i] := Str;
      exit;
    end;
    Tbl[i] := Copy(Str, 1, n - 1);
    Str := Copy2(Str, n + 1, -1);
  end;
end;

function AnsiPosR(Word: string; Str: string): integer;
var
  n: integer;
  nn: integer;
  s: string;
begin
  result := 0;
  nn := 0;
  s := Str;
  while true do begin
    n := AnsiPos(Word, s);
    if n <= 0 then begin
      break;
    end;
    result := nn + n;
    nn := nn + (n + Length(Word) - 1);
    s := Copy2(s, n + Length(Word), -1);
  end;
end;

function AnsiPosR2(Str: string): integer;
var
  n1: integer;
  n2: integer;
begin
  n1 := AnsiPosR(' ', Str);
  n2 := AnsiPosR(#$0a, Str);
  if n2 > n1 then begin
    n1 := n2;
  end;
  result := n1;
end;

function ConvCrToSpace(Str: string): string;
var
  n: integer;
  i: integer;
  c: char;
begin
  result := '';
  n := Length(Str);
  for i := 1 to n do begin
    c := Str[i];
    if c = #$0d then begin
    end else if c = #$0a then begin
      result := result + ' ';
    end else begin
      result := result + c;
    end;
  end;
end;

function SkipSpace(Str: string): string;
var
  n: integer;
  i: integer;
  k: integer;
  c: char;
begin
  n := Length(Str);
  k := 1;
  for i := 1 to n do begin
    c := Str[i];
    if not ((c = ' ') or (c = #$0d) or (c = #$0a)) then begin
      k := i;
      break;
    end;
  end;
  Str := Copy(Str, k, n - k + 1);
  n := Length(Str);
  k := n;
  for i := n downto 1 do begin
    c := Str[i];
    if not ((c = ' ') or (c = #$0d) or (c = #$0a)) then begin
      k := i;
      break;
    end;
  end;
  result := Copy(Str, 1, k);
end;

function IsNumber(Str: string): boolean;
var
  n: integer;
  i: integer;
  c: char;
begin
  result := false;
  Str := SkipSpace(Str);
  n := Length(Str);
  if n <= 0 then begin
    exit;
  end;
  for i := 1 to n do begin
    c := Str[i];
    if not (
      (('0' <= c) and (c <= '9'))
    ) then begin
      exit;
    end;
  end;
  result := true;
end;

function IsTripString(Str: string): boolean;
var
  n: integer;
  i: integer;
  c: char;
begin
  result := false;
  Str := SkipSpace(Str);
  n := Length(Str);
  if n <> 10 then begin
    exit;
  end;
  for i := 1 to n do begin
    c := Str[i];
    if not (
      (('0' <= c) and (c <= '9')) or
      (('a' <= c) and (c <= 'z')) or
      (('A' <= c) and (c <= 'Z')) or
      ('/' = c) or (c = '.')
    ) then begin
      exit;
    end;
  end;
  result := true;
end;

function IsFileSizeString(Str: string): boolean;
var
  n: integer;
  i: integer;
  k: integer;
  c: char;
begin
  result := false;
  Str := SkipSpace(Str);
  n := Length(Str);
  if n > 13 then begin
    exit;
  end;
  k := 1;
  for i := n downto 1 do begin
    c := Str[i];
    if k = 4 then begin
      if c <> ',' then begin
        exit;
      end;
      k := 1;
    end else begin
      if not (('0' <= c) and (c <= '9')) then begin
        exit;
      end;
      k := k + 1;
    end;
  end;
  result := true;
end;

function IsHashString(Str: string): boolean;
var
  n: integer;
  i: integer;
  c: char;
begin
  result := false;
  Str := SkipSpace(Str);
  n := Length(Str);
  if n <> 32 then begin
    exit;
  end;
  for i := 1 to n do begin
    c := Str[i];
    if not ((('0' <= c) and (c <= '9')) or (('a' <= c) and (c <= 'f'))) then begin
      exit;
    end;
  end;
  result := true;
end;

function SeparateHash(var Str: string): string;
var
  n: integer;
  s: string;
begin
  result := '';
  Str := SkipSpace(Str);
  if Str[Length(Str)] <> ')' then begin
    exit;
  end;
  n := AnsiPosR(' (', Str);
  if n <= 0 then begin
    exit;
  end;
  s := Copy2(Str, n + 2, Length(Str) - (n + 2 - 1) - 1);
  if not IsHashString(s) then begin
    exit;
  end;
  Str := Copy(Str, 1, n - 1);
  Str := SkipSpace(Str);
  result := s;
end;

function ConvTag(Str: string; Size: integer): string;
var
  i: integer;
  c: char;
begin
  result := '';
  i := 0;
  while i < Size do begin
    c := Str[i];
    if c = '&' then begin


    end else begin
      result := result + c;
    end;
  end;
end;

procedure WinnySeparateHash2(Str: string; Size: integer; var Keyword: string; var Hash: string);
var
  n: integer;
  s: string;
begin
  Str := Copy(Str, 1, Size);
  Str := StringReplace(Str, '<b>', '', [rfReplaceAll]);
  Str := StringReplace(Str, '</b>', '', [rfReplaceAll]);
  Str := StringReplace(Str, '&nbsp;', ' ', [rfReplaceAll]);
  Str := StringReplace(Str, '&lt;', '<', [rfReplaceAll]);
  Str := StringReplace(Str, '&gt;', '>', [rfReplaceAll]);
  Str := StringReplace(Str, '&amp;', '&', [rfReplaceAll]);
  Hash := '';
  Str := SkipSpace(Str);
  n := AnsiPosR(' ', Str);
  if n > 0 then begin
    s := Copy2(Str, n + 1, -1);
    Str := SkipSpace(Copy(Str, 1, n - 1));
  end else begin
    s := Str;
    Str := '';
  end;
  if IsHashString(s) then begin
    Hash := SkipSpace(s);

    n := AnsiPosR(' ', Str);
    if n > 0 then begin
      s := Copy2(Str, n + 1, -1);
      if IsFileSizeString(s) then begin
        Str := SkipSpace(Copy(Str, 1, n - 1));
      end;
    end;

    n := AnsiPosR(' ', Str);
    if n > 0 then begin
      s := Copy2(Str, n + 1, -1);
      if IsTripString(s) then begin
        Str := SkipSpace(Copy(Str, 1, n - 1));
      end;
    end;

    Keyword := SkipSpace(Str);
  end;
end;

function WinnySeparateBoard(var Keyword: string): string;
var
  n: integer;
begin
  result := '';
  if AnsiPos('[BBS_', Keyword) = 1 then begin
    n := AnsiPos(']', Keyword);
    if n > 0 then begin
      result := Copy(Keyword, 1, n);
      Keyword := Copy2(Keyword, n + 1, -1);
      Keyword := SkipSpace(Keyword);
    end;
  end;
end;


function ShingetsuConvSubject(txt: String) : String;
var
  ln: string;
  fileName: string;
  title: string;
  num: string;
begin
  result := '';
  SeparateWord2('<LI>', txt);
  while txt <> '' do begin
    ln := SeparateWord2('<LI>', txt);
    if AnsiPos('/THREAD/', ln) > 0 then begin
      SeparateWord('/THREAD/', ln);
      fileName := SeparateQuote(ln);
      SeparateWord('>', ln);
      title := SeparateWord2('</A>', ln);
      SeparateWord2('(', ln);
      num := SeparateWord(')', ln);
      if num = '?' then begin
        num := '0';
      end;
      result := result + fileName + ',' + title + '(' + num + ')' + #$0a;
    end;
  end;
end;

end.


