// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997,1998,1999,2000
//
// LHA32֘AW[ LHA32.PAS
//
// v1.00:Jo[W
// v1.01:Open/Close \bh FindOpen/FindClose ɉ
// v1.02:uses ߂sgpjbg Forms O
//       t@CXgp[^̌^ TStrings ɕύX
//       ^Cg̃Rg኱ύX
// v1.03:Delphi 3 ɑΉ
// v1.05:ɓACe폜p\bhǉ
//       LoadDll/FreeDll ̍\ύX
//       Ƀt@C@\ǉ
// v1.09:Update/ExtractTo \bh PackTo/UnpackTo ɉ
// v1.11:eNX̃\bh錾̌
//       svϐ̐錾폜
// v1.12:TArchiveFile  Output/OutputSize vpeBǉ
//       \bh̎኱ύX
// v1.13:uses ߂sgpjbg Forms OȂĂ
//       gr IvV̌^̌C
// v1.16:ƎtB^ɂƂȂ Options.d p~ɑΉ
// v1.17:LoadDll/FreeDll/IsXXXArchive ̍\ύX
// v1.20:ȉ𓀏ɍ쐬pXw@\ǉ
// v1.21:LoadDll/FreeDll ̉xύX
// v1.22:o߃CxgT|[gǉ
// v1.23:CheckArchive \bhǉ
//       ȃ\bh̉
// v1.25:ZIP32J.DLLł̖O"["܂ރt@Cւ̑Ή
// v1.28:WJ@\̃T|[gǉ
//	      CheckArchive \bh̖߂ľ^ύX
//       UNLHA32.DLL v1.46܂ł̃oO΍R[hǉ
// v1.30:e\bh FileList ̌^ύX
// v1.32:IsSetOwnerWinow/KillOwnerWindow ̎ύX
// v1.35:TLha32.Lha  CmdLine ĂȂs̏C
// v1.38:DLL ̃Gg|Cg̎擾@ύX
// v1.43:UNLHA32.DLL 1.86 ȑO̕sւ̑΍R[hǉ
// v1.48:UNLHA32.DLL 1.87b ȍ~Œǉꂽ gy nIvṼT|[gǉ
//
unit LHA32;

interface

uses
	Windows,
	SysUtils,
	Classes,
	Archives;

type
	TLha32 = class( TArchiver )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	protected
		function  BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;

		function  FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function  FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function  FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo				   ):integer; override;
		function  FindClose( hArc:THArc													   ):integer; override;

	public
		function Lha( Handle:HWND;cmdline:string;var Output:string ):Integer;
		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function RemoveItems  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function MakeSfx      ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String                                           ;var Output:string ):Integer; override;
		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD   ):Integer; override;
		function CheckArchive (             ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;
		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
		function KillOwnerWindowEx( Handle:HWND							     ):boolean; override;
	end;

	function IsLhaArchive( ArchiveFileName:string ):boolean;

const
	SFX_NOT				=	0;		// ʏ̏

	SFX_DOS_S			=	1;		// LHA's SFX n (small)
	SFX_DOS_204S		=	1;		// LHA's SFX 2.04S ȍ~
	SFX_DOS_213S		=	1;		// LHA's SFX 2.04S ȍ~
	SFX_DOS_250S		=	2;		// LHA's SFX 2.50S ȍ~
	SFX_DOS_260S		=	3;		// LHA's SFX 2.60S ȍ~
	SFX_DOS_265S		=	3;		// LHA's SFX 2.60S ȍ~

	SFX_DOS_L			=	51; 	// LHA's SFX n (large)
	SFX_DOS_204L		=	51; 	// LHA's SFX 2.04L ȍ~
	SFX_DOS_213L		=	51; 	// LHA's SFX 2.04L ȍ~
	SFX_DOS_250L		=	52; 	// LHA's SFX 2.50L ȍ~
	SFX_DOS_260L		=	53; 	// LHA's SFX 2.60L ȍ~
	SFX_DOS_265L		=	53; 	// LHA's SFX 2.60L ȍ~

	SFX_DOS_LARC		=	201;	// SFX by LARC n
	SFX_DOS_LARC_S		=	201;	// SFX by LARC (small)
	SFX_DOS_LARC_L		=	202;	// SFX by LARC (large)

	SFX_DOS_LHARC		=	301;	// LHarc's SFX n
	SFX_DOS_LHARC_S	=	301;	// LHarc's SFX (small)
	SFX_DOS_LHARC_L	=	351;	// LHarc's SFX (large)

	SFX_WIN16_213		=	1001;	// LHA's SFX 2.13.w16 n
	SFX_WIN16_213_1	=	1001;	// WinSFX 2.13.w16.1
	SFX_WIN16_213_2	=	1002;	// WinSFX 2.13.w16.2
	SFX_WIN16_213_3	=	1003;	// WinSFX 2.13.w16.3 ȍ~

	SFX_WIN16_250		=	1011;	// LHA's SFX 2.50.w16 n
	SFX_WIN16_250_1	=	1011;	// WinSFXM 2.50.w16.0001 ȍ~
	SFX_WIN16_255_1	=	1021;	// WinSFXM 2.55.w16.0001 ȍ~

	SFX_WIN32_213		=	2001;	// LHA's SFX 2.13.w32 n
	SFX_WIN32_213_1	=	2001;	// WinSFX32 2.13.w32.1 ȍ~
	SFX_WIN32_213_3	=	2002;	// WinSFX32 2.13.w32.3 ȍ~

	SFX_WIN32_214_1	=	2003;	// WinSFX32 2.14.w32.0001 ȍ~

	SFX_WIN32_250		=	2011;	// LHA's SFX 2.50.w32 n
	SFX_WIN32_250_1	=	2011;	// WinSFX32M 2.50.w32.0001 ȍ~
	SFX_WIN32_250_6	=	2012;	// WinSFX32M 2.50.w32.0006 ȍ~

	SFX_LZHSFX			=	2051;	// LZHSFX n
	SFX_LZHSFX_1002	=	2051;	// LZHSFX 1.0.0.2 ȍ~
	SFX_LZHSFX_1100	=	2052;	// LZHSFX 1.1.0.0 ȍ~

	SFX_LZHAUTO			=	2101;	// LZHAUTO n
	SFX_LZHAUTO_0002	=	2101;	// LZHAUTO 0.0.0.2 ȍ~
	SFX_LZHAUTO_1000	=	2102;	// LZHAUTO 1.0.0.0 ȍ~
	SFX_LZHAUTO_1002	=	2102;	// LZHAUTO 1.0.0.0 ȍ~
	SFX_LZHAUTO_1100	=	2103;	// LZHAUTO 1.1.0.0 ȍ~

	SFX_WIN32_LHASA	=	3001;	// Lhasa CXg[

	SFX_DOS_UNKNOWN	=	9901;	// FłȂ DOS SFX
	SFX_WIN16_UNKNOWN	=	9911;	// FłȂ Win16 SFX
	SFX_WIN32_UNKNOWN	=	9921;	// FłȂ Win32 SFX

implementation

{$ifndef DISABLEBUGFIX001}		//	UnlhaOpenArchive Ώۂ̃t@C
	{$define	ENABLEBUGFIX001}	//	J܂܂ɂĂ܂Ƃsւ
{$endif}								//	΍R[hLɂ
										//	̕s UNLHA32.DLL v1.47a ő΍􂳂ꂽ
										//	s܂񂾃o[W̗ʗʂ
										//	΂炭΍R[hĂƂɂ

{$ifndef DISABLEBUGFIX002}		//	fBNg𑊑΃pXŎw肷Ɣ
//	{$define	ENABLEBUGFIX002}	//	sւ̑΍R[hLɂ
{$endif}								//	̕s UNLHA32.DLL v1.86a ő΍􂳂ꂽ
										//	s܂񂾃o[W̗ʗʂ
										//	΂炭΍R[hĂƂɂ

uses
	Filters;

//---------------------------------------------------------------------
var
	FArchiver:		TArchiverDll;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;
	FArchiver := TArchiverDll.Create( 'LHA `','UNLHA32.DLL','Unlha' );
	FArchiver.LoadDLL;
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//---------------------------------------------------------------------
class procedure TLha32.LoadDll;
begin
	Lha32.LoadDLL;
end;

class procedure TLha32.FreeDll;
begin
	Lha32.FreeDll;
end;

function TLha32.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
{$IFDEF ENABLEBUGFIX002}
	if DstPath <> '' then DstPath := ExpandUNCFileName( DstPath );
{$ENDIF}
	FCmdLine := BuildCmdLine( 'x',ArchiveFileName,Options,DstPath,FileList,ruOnUnpack in Options.ResFileUsage );
	result := lha( Handle,FCmdLine,Output );
end;

function TLha32.PackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'u',ArchiveFileName,Options,BaseDir,FileList,ruOnPack in Options.ResFileUsage );
	result := lha( Handle,FCmdLine,Output );
end;

function TLha32.RemoveItems( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'd',ArchiveFileName,Options,'',FileList,ruOnRemoveItem in Options.ResFileUsage );
	result := lha( Handle,FCmdLine,Output );
end;

function TLha32.UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'f',ArchiveFileName,Options,BaseDir,FileList,ruOnUpdate in Options.ResFileUsage );
	result := lha( Handle,FCmdLine,Output );
end;

function TLha32.MakeSfx( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 's',ArchiveFileName,Options,DstPath,[nil],false );
	result := lha( Handle,FCmdLine,Output );
end;

function TLha32.UnpackToMem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD ):Integer;
begin
	FCmdLine := BuildCmdLine( '',ArchiveFileName,Options,'',[FileName],false );
	result := FArchiver.ExtractMem( Handle,PChar( FCmdLine ),lpvBuffer,dwSize,nil,nil,lpdwWriteSize );
end;

function TLha32.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode+CheckOptions );
end;

function TLha32.SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
begin
	inherited SetOwnerWindowEx( Handle,lpArcProc );
	result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
end;

function TLha32.KillOwnerWindowEx( Handle:HWND ):boolean;
begin
	result := FArchiver.KillOwnerWindowEx( Handle );
	inherited KillOwnerWindowEx( Handle );
end;

function TLha32.Lha( Handle:HWND;CmdLine:string;var Output:string ):Integer;
begin
	result := FArchiver.ArchiverProc( Handle,PChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TLha32.BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
begin
	with Options do begin
		CmdLine := TCmdOpt.Create;
		try
			CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

{$IFNDEF NoArchiverAssert}
			if( Cmd='x' )
			then begin
				Assert( jse <> aoiUnAssigned,'jse IvVݒ肳Ă܂B' );
				//	𓀎 jse IvV͕Kw肵ĉB
				//	jse IvV̓eɂĂ UNLHA32.DLL Yt COMMAND.TXT
				//	API.TXT ȂǂQƂĉB
				//	IvV̈ӖȂꍇ 1 w肵ĉB
			end;
			Assert( jso <> aoiUnAssigned,'jso IvVݒ肳Ă܂B' );
			//	jso IvV͕Kw肵ĉB
			//	jso IvV̓eɂĂ UNLHA32.DLL Yt COMMAND.TXT
			//	ȂǂQƂĉB
			//	IvV̈ӖȂꍇ 1 w肵ĉB
{$ENDIF}

			CmdLine.AddIntOpt( 'a'	,a	 );		//	a[0|1|2]				̍ČB
			CmdLine.AddIntOpt( 'c'	,c	 );		//	c[0|1]				^CX^vȗ
	//		CmdLine.AddIntOpt( 'd'	,d	 );		//	d[0|1]				fBNg̊i[
			CmdLine.AddIntOpt( 'e'	,e	 );		//	e[0|1]				TCY𔼕ɂĈk
			CmdLine.AddIntOpt( 'f'	,f	 );		//	f[0|1]				fBXNcʃ`FbN̒~
			CmdLine.AddIntOpt( 'h'	,h	 );		//	h[0|1|2|3]			wb_̌`w
			CmdLine.AddIntOpt( 'i'	,i	 );		//	i[0|1|2]				t@CIő啶Ə
			CmdLine.AddIntOpt( 'l'	,l	 );		//	l[0|1|2]				WJÕt@C̕\@̕ύX
			CmdLine.AddIntOpt( 'm'	,m	 );		//	m[0|1|2]				 yes Ɖ

			if not CallBackEnabled
			then CmdLine.AddIntOpt( 'n' ,n )		//	n[0|1]				WJ󋵃_CAO\̗}~
			else CmdLine.AddIntOpt( 'n' ,1 );	//	n[0|1]				WJ󋵃_CAO\̗}~

			CmdLine.AddIntOpt( 'o'	,o	 );		//	o[0|1|2]				`ŏɂ쐬
			CmdLine.AddIntOpt( 'p'	,p	 );		//	p[0|1|2]				SpXōv
			CmdLine.AddIntOpt( 'r'	,r	 );		//	r[0|1|2]				ċAI
			CmdLine.AddIntOpt( 's'	,s	 );		//	s[0|1]				XLbv\̗}
			CmdLine.AddIntOpt( 't'	,t	 );		//	t[0|1]				ɂ̍XV̎w

			CmdLine.AddIntOpt( 'u'	,u	  );		//	u[0|1]				t@C̍XViV́j
			CmdLine.AddPath1 ( 'w'  ,w   );		//	w[0|1|<Dir>]		ƗpfBNg̎w
			CmdLine.AddIntOpt( 'x'	,x	  );		//	x[0|1]				fBNgLɂ
			CmdLine.AddIntOpt( 'y'	,y	  );		//	y[0|1]				SĂ̎ yes Ɖ
			CmdLine.AddIntOpt( 'z'	,z	  );		//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
			CmdLine.AddIntOpt( 'jc' ,jc  );		//	jc[0|1]				jwb_𖳎
			CmdLine.AddIntOpt( 'jd' ,jd  );		//	jd[<TCY>]		fBXN̋󂫗eʂmF
			CmdLine.AddIntOpt( 'je' ,je  );		//	je[<TCY>]		Huffman obt@̑傫w
			CmdLine.AddIntOpt( 'jf' ,jf  );		//	jf[0|1]				[gL̍폜
			CmdLine.AddIntOpt( 'jh' ,jh  );	 	//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
			CmdLine.AddIntOpt( 'ji' ,ji  );		//	ji[0|1]				Zt@CŊi[
			CmdLine.AddIntOpt( 'jm' ,jm  );		//	jm[0|1|2|3|4]		k`w
			CmdLine.AddIntOpt( 'jn' ,jn  );		//	jn[0|1]				VKt@Ĉ
			CmdLine.AddStrOpt( 'jo' ,jo  );		//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
			CmdLine.AddStrOpt( 'job',job );		//	job[<w>]	YYMMDDHHMMSS ̓tȑO
			CmdLine.AddIntOpt( 'jp' ,jp  );		//	jp[0|1]				io[vOXEo[ŕ\
			CmdLine.AddIntOpt( 'jr' ,jr  );		//	jr[0|1]				t@C̒u
			CmdLine.AddIntOpt( 'jsb',jsb );		//	jsb[0|1]				bZ[W[v񂳂Ȃ
			CmdLine.AddIntOpt( 'jsc',jsc );		//	jsc[0|1]				WJłȂt@CԂ
			CmdLine.AddIntOpt( 'jsd',jsd );		//	jsd[0|1]				󂫗eʎ擾Ɏsꍇ̏w
			CmdLine.AddIntOpt( 'jse',jse );		//	jse[0|1]				WJ̏㏑I[vG[Ƃ
			CmdLine.AddIntOpt( 'jsf',jsf );		//	jsf[0|1]				^CX^v̕␳sȂ
			CmdLine.AddIntOpt( 'jsl',jsl );		//	jsl[0|1]				kEi[t@C̏d`FbNsȂ
			CmdLine.AddIntOpt( 'jso',jso );		//	jso[0|1]				SH_DENYNO ł̃I[vsȂ
			CmdLine.AddIntOpt( 'jss',jss );		//	jss[0|1]				LG[̏ꍇɏ𑱍s
			CmdLine.AddIntOpt( 'jst',jst );		//	jst[0|1]				FILETIME \̃wb_̊i[ȗ
			CmdLine.AddIntOpt( 'jsv',jsv );		//	jsv[0|1]				ɑɏɂ`FbN
			CmdLine.AddIntOpt( 'jsz',jsz );		//	jsz[0|1]				̊gqt
			CmdLine.AddIntOpt( 'jw' ,jw  );		//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
			CmdLine.AddFList2( 'jx' ,[jx] );		//	jx[<t@C>]	Ot@C
			CmdLine.AddIntOpt( 'jyc',jyc );		//	jyc[0|1]				fBNg쐬̊mFȗ
			CmdLine.AddIntOpt( 'jyd',jyd );		//	jyd[0|1]				t@C폜̊mFȗ
			CmdLine.AddIntOpt( 'jyk',jyk );		//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
			CmdLine.AddIntOpt( 'jyn',jyn );		//	jyn[0|1]				Vt@C̗v̏ȗ
			CmdLine.AddIntOpt( 'jyo',jyo );		//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
			CmdLine.AddStrOpt( 'jz' ,jz  );		//	jz[<t@C>]	t@C߂̃t@C
			CmdLine.AddIntOpt( 'ga' ,ga  );		//	ga[0|1]				ݕs𖳎
			CmdLine.AddIntOpt( 'gd' ,gd  );		//	gd[0|1]				]ȃf[^̍폜
			CmdLine.AddIntOpt( 'ge' ,ge  );		//	ge[0|1]				ŏ̊gqF
			CmdLine.AddIntOpt( 'gf' ,gf  );		//	gf[0|1|2]			łɂt@C̍XV
			CmdLine.AddIntOpt( 'gj' ,gj  );		//	gj[0|1]				x ߂ e ߂ƓlƌȂ
			CmdLine.AddIntOpt( 'gm' ,gm  );		//	gm[0|1]				G[bZ[W\̗}~
			CmdLine.AddIntOpt( 'gn' ,gn  );		//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
			CmdLine.AddIntOpt( 'go' ,go  );		//	go[0|1]				_CAÕI[i[EBhE̎w
			CmdLine.AddIntOpt( 'gp' ,gp  );		//	gp[0|1]				EBhE Disable ɂȂ
			CmdLine.AddStrOpt( 'gr' ,gr  );		//	gr[<t@C>]	ύXt@C
			CmdLine.AddIntOpt( 'gs' ,gs  );		//	gs[<TCY>]		wb_TCY̎w
			CmdLine.AddIntOpt( 'gu' ,gu  );		//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
			CmdLine.AddIntOpt( 'gw' ,gw  );		//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬
			CmdLine.AddIntOpt( 'gya',gya );		//	gya[0|1]				  [-gya1]
			CmdLine.AddIntOpt( 'gyc',gyc );		//	gyc[0|1]				^CX^v`FbN̏ȗ  [-gyc1]
			CmdLine.AddStrOpt( 'gyd',gyd );		//	gyd<fBNg>	𓀐fBNgw
			CmdLine.AddStrOpt( 'gye',gye );		//	gye<R}h>		sR}hw
			CmdLine.AddIntOpt( 'gyo',gyo );		//	gyo[0|1]				㏑w(㏑mFsȂ)  [-gyo0]
			CmdLine.AddIntOpt( 'gyq',gyq );		//	gyq[0|1]				sw  [-gyq0]
			CmdLine.AddIntOpt( 'gys',gys );		//	gys[0|1]				₃`FbNs  [-gys0]
			CmdLine.AddStrOpt( 'gyt',gyt );		//	gyt<^Cg>		𓀐fBNg^Cg̐ݒ
			CmdLine.AddStrOpt( 'gyw',gyw );		//	gyw<^Cg>		_CAÕ^Cg̐ݒ
			CmdLine.AddIntOpt( 'gyx',gyx );		//	gyx[0|1]				fBNg̕s  [-gyx0]

			CmdLine.Add( UserOptions );

			AddFileSpec1( CmdLine,ArchiveFileName,Path );
			AddFileSpec2( CmdLine,Options,FileList,UseResFile );

			result := cmd + CmdLine.Str;
		finally
			CmdLine.Free;
		end;
	end;
end;

function TLha32.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	result:= FArchiver.OpenArchive( Handle,PChar( ExpandFileName( ArchiveFileName )),dwMode );
end;

function TLha32.FindClose( hArc:THArc ):integer;
begin
	result := FArchiver.CloseArchive( hArc );
end;

function TLha32.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
end;

function TLha32.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

function IsLhaArchive( ArchiveFileName:string ):boolean;
var
	hArc:  THARC;
begin
	try
		LoadDLL;
		ArchiveFileName := ExpandFileName( ArchiveFileName );
{$ifdef ENABLEBUGFIX001}
		if FArchiver.CheckArchive( PChar( ArchiveFileName ),CHECKARCHIVE_ALL ) <> 0	// Ƀ`FbN
		then begin
{$endif}
			hArc := FArchiver.OpenArchive( 0,PAnsiChar( ArchiveFileName ),M_REGARDLESS_INIT_FILE+M_ERROR_MESSAGE_OFF );
			FArchiver.CloseArchive( hArc );
			result := ( hArc <> 0 );
{$ifdef ENABLEBUGFIX001}
		end else begin
			result := False;
		end;
{$endif}
	except
		result := false;
	end;
end;

end.
